#!/usr/bin/perl
# 使い方:
#   1. nikを解凍したディレクトリでnik2sdを実行
#   2. converted.txtが作られるので、これを~/Library/BotCli/surface_description.txtにコピペ
#      文字コードに注意。生成されたconverted.txtはShift_JISだが、surface_description.txtはUTF-8である。
package main;
use IO::Dir;
use IO::File;
our $VERSION = '###VERSION###';

my $out;
sub write {
    if (!defined $out) {
	$out = IO::File->new('converted.txt','w');
    }
    $out->print($_[0]);
}

sub readname {
    my $result;
    eval {
	($result = IO::File->new($_[0],'r')->getline) =~ s/[\r\n]+$//g;
    }; if ($@) {
	die "Couldn't read file $_[0]\n";
    }
    $result;
}

sub readtable {
    my $in = IO::File->new($_[0],'r');
    map {
	my ($id,$name) = m/^\s*(.+?)\s*,\s*(.+?)\s*$/;
	"$id: $name";
    } $in->getlines;
}

sub expandtable {
    my $dir = IO::Dir->new('.');
    while (defined($_ = $dir->read)) {
	if (-f && $_ =~ $_[0]) {
	    foreach (&readtable($_)) {
		&write("\t\t$_\n");
	    }
	}
    }
}

print "nik2sd #$VERSION started.\n";
my $sakuraname = &readname('sur-a.txt');
my $keroname = &readname('sur-b.txt');
&write("ghost:$sakuraname\n");
&write("{\n");
&write("\t// This description has been converted from BSE nik.\n");
&write("\t// http://k-a2shi.hp.infoseek.co.jp/bottle/bse/\n");
&write("\tsakura:$sakuraname\n");
&write("\t{\n");
&expandtable('sur-a\d+\.txt');
&write("\t}\n");
&write("\n");
&write("\tkero:$keroname\n");
&write("\t{\n");
&expandtable('sur-b\d+\.txt');
&write("\t}\n");
&write("}\n");
print "done.\n";
exit;
